# mini/plugs/list.py
#
#

## IMPORTS


from mini.utils import error, time_string, to_time, time_stamp, do_objects, format_obj, short_date
from mini import kernel

## basic imports

import threading
import logging
import re

# commands function

def do_list(event):
    if not event.rest: event.reply("choose one of run, cfg, plugs, threads") ; return
    name = event.args[1]
    if name == "threads": event.reply(" ".join(map(str, threading.enumerate()))) ; return
    what = kernel
    result = None
    for n in name.split("."):
        try: result = getattr(what, n)
        except AttributeError: result = None ; break 
        what = result
    if not result: return
    try: event.reply(" ".join(result.keys()))
    except: event.reply(result)

kernel.register("ls", do_list)
