# mini/plugs/test.py
#
#

""" test plugin. """

## shout imports

from mini import Object, kernel, __version__

## test commands

def test(event): event.reply("yooo %s !!" % event.nick)

kernel.register("test", test)

## test_json command

def test_json(event): event.reply(event.make_json(indent=True))

kernel.register("test_json", test_json)

##  test_load command

def test_load(event):
     e = Object()
     e.txt= "this is a test and nothing more than a test..."
     e.save()
     e.load()
     event.reply(e.make_json())
     event.display(e)

kernel.register("test_load", test_load)

## test_unicode command

def test_unicode(event):
    event.reply("Đíť ìš éèñ ëņċøďıńğŧęŝţ· .. にほんごがはなせません .. ₀0⁰₁1¹₂2²₃3³₄4⁴₅5⁵₆6⁶₇7⁷₈8⁸₉9⁹ .. ▁▂▃▄▅▆▇▉▇▆▅▄▃▂▁ .. .. uǝʌoqǝʇsɹǝpuo pɐdı ǝɾ ʇpnoɥ ǝɾ - <AcidNerd> because of é or è")

kernel.register("test_unicode", test_unicode)

## test_save command

def test_save(event): event.save()

kernel.register("test_save", test_save)

def do_version(event): event.reply(__version__)

kernel.register("version", do_version)

def test_all(event):
    bot = event.get_target()
    for cmnd in kernel.cmnds:
        if cmnd == "test_all": continue
        o = Object()
        o.txt = cmnd
        o.is_cmnd = True
        bot.put(o)

kernel.register("test_all", test_all)

def test_print(event): print(event)

kernel.register("test_print", test_print)