# mini/plugs/add.py
#
#

""" add a value. """

## IMPORTS

from mini import kernel, Object

import logging
import time

## add command

def do_add(event):
    try: key, value = event.rest.split(" ", 1)
    except ValueError: logging.warn("add <key> <value>") ; return
    o = Object()
    o.added = time.ctime(time.time())
    o[key] = value
    o.save()
    event.reply("added")

kernel.register("add", do_add)
