# mini/plugs/all.py
#
#

## IMPORTS

from mini import kernel, Object

import os
import time

def do_all(event):
    attrslist = []
    result = []
    sep = ", "
    for obj in event.objects():
        for key in obj.reduced():
            if key.startswith("X"): continue
            if key.startswith("x"): continue
            if not key.islower(): continue
            if "-" in key: continue
            if key not in attrslist: attrslist.append(key)
    event.reply(sep.join(attrslist)) 

kernel.register("all", do_all)
