# mini/plugs/output.py
#
#

""" output a set of objects. """

## IMPORTS

from mini.utils import time_string, time_stamp, reduced_keys
from mini import kernel, Object

import logging
import json
import sys

## do_find command

def do_output(event):
    for txt_in in sys.stdin.readlines():
        obj = Object()
        obj.load_json(txt_in)
        res = ""
        for arg in event.args:
            try: value = getattr(obj, arg)
            except AttributeError: continue
            if not value: continue
            res += "%s -=- " % value
        event.reply(res[:-5])

kernel.register("output", do_output)
